library ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity cont6_as_reset is
  port (clock : in  std_logic;
        reset : in  std_logic;
        Z     : out std_logic_vector(5 downto 0)
        );
end cont6_as_reset;

architecture myarch of cont6_as_reset is
  signal t : std_logic_vector(0 to 5);
begin
  process (clock, reset)
  begin
    if reset = '1' then
      t <= "000000";
    elsif (clock'event and clock = '1') then
      t <= t + "000001";
    end if;
  end process;

  Z <= t;
end myarch;





