library ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity cont8_as_reset_up is
  port (clock : in  std_logic;
        reset : in  std_logic;
        up    : in std_logic;
        Z     : out std_logic_vector(7 downto 0)
        );
end cont8_as_reset_up;

architecture myarch of cont8_as_reset_up is
  signal t : std_logic_vector(0 to 7);
begin
  process (clock, reset)
  begin
    if reset = '1' then
      t <= "00000000";
    elsif (clock'event and clock = '1') then
  	if up = '1' then
	  t <= t + "00000001";
	else
	  t <= t - "00000001";
	end if;
    end if;
  end process;

  Z <= t;
end myarch;






