entity shreg8_tb is
end shreg8_tb;

architecture testbench of shreg8_tb is

  component shreg8 is
    port (clock : in  bit;
          X    : in bit;
          Z     : out bit
         );
  end component;

  signal X, Z  : bit;
  signal clock : bit;
  signal ris : bit := '0';
  signal t : bit_vector(8 downto 0); -- t(0) dovrebbe assumere il valore dato a Z
  signal f : bit;
  
begin
  uut : shreg8 port map (clock, X, Z);

  -- finche' ris vale 0 tutto dovrebbe andare bene.
 ris_p: process(clock, X, Z)
 begin
   if clock'event and clock = '1' then
     t(7 downto 0) <= t(8 downto 1);
     t(8) <= X;
     f <= X; -- f e' X campionato dal clock
   end if;
   if Z = t(0) then 
     ris <= '0';
   else
     ris <= '1';
   end if;
 end process;
 
  X_p: process
  begin   -- un po' di valori a caso
    X <= '1';
    wait for 0.1 ns;
    X <= '0';
    wait for 6 ns;
    X <= '1';
    wait for 3 ns;
    X <= '1';
    wait for 5 ns;
    X <= '0';
    wait for 6 ns;
    X <= '1';
    wait for 4 ns;
    X <= '0';
    wait for 8 ns;
    X <= '0';
    wait for 4 ns;
    X <= '1';
    wait for 1 ns;
    X <= '0';
    wait for 4 ns;
    X <= '1';
    wait for 3 ns;
    X <= '1';
    wait for 7 ns;
    X <= '0';
    wait for 5 ns;
    X <= '1';
    wait for 4 ns;
    X <= '0';
    wait for 3 ns;
  end process;

  clock_p : process
  begin
    clock <= '0';
    wait for 5 ns;
    clock <= '1';
    wait for 5 ns;
  end process;

end testbench;








