entity mux8_tb is
end mux8_tb;

architecture testbench of mux8_tb is

  component mux8 is
    port (X   : in  bit_vector(7 downto 0);
          SEL : in  bit_vector(2 downto 0);
          Z   : out bit
         );
  end component;

  signal X: bit_vector (7 downto 0);
  signal SEL: bit_vector (2 downto 0);
  signal Z : bit;
  signal ris : bit := '0';

begin
  uut : mux8 port map (X, SEL, Z);

  ris <= '0' when ((SEL = "000" and Z = X(0)) or
                   (SEL = "001" and Z = X(1)) or
                   (SEL = "010" and Z = X(2)) or
                   (SEL = "011" and Z = X(3)) or
                   (SEL = "100" and Z = X(4)) or
                   (SEL = "101" and Z = X(5)) or
                   (SEL = "110" and Z = X(6)) or
                   (SEL = "111" and Z = X(7)) 
                   )
         else '1';


  X_p: process         -- un po' di valori a caso
   begin
      X <= "00000000";
      wait for 10 ns;
      X <= "01000001";
      wait for 10 ns;
      X <= "00100010";
      wait for 10 ns;
      X <= "10000011";
      wait for 10 ns;
      X <= "01000100";
      wait for 10 ns;
      X <= "00100101";
      wait for 10 ns;
      X <= "00010110";
      wait for 10 ns;
      X <= "10010111";
      wait for 10 ns;
      X <= "01001000";
      wait for 10 ns;
      X <= "10001001";
      wait for 10 ns;
      X <= "00001010";
      wait for 10 ns;
      X <= "01001011";
      wait for 10 ns;
      X <= "00101100";
      wait for 10 ns;
      X <= "11001101";
      wait for 10 ns;
      X <= "01011110";
      wait for 10 ns;
      X <= "11111111";
      wait for 10 ns;

   end process;

 SEL_p: process  
 begin
      SEL <= "000";
      wait for 11 ns;
      SEL <= "001";
      wait for 11 ns;
      SEL <= "010";
      wait for 11 ns;
      SEL <= "011";
      wait for 11 ns;
      SEL <= "100";
      wait for 11 ns;
      SEL <= "101";
      wait for 11 ns;
      SEL <= "110";
      wait for 11 ns;
      SEL <= "111";
      wait for 11 ns;
 end process;

end testbench;

