entity reg8_as_reset is
  port (X     : in  bit_vector(7 downto 0);
        clock : in  bit;
        reset : in  bit;
        Z     : out bit_vector(7 downto 0)
        );
end reg8_as_reset;

architecture myarch of reg8_as_reset is
begin
  process (clock, reset)
  begin
    if reset = '1' then
      Z <= "00000000";
    elsif (clock'event and clock = '1') then
      Z <= X;
    end if;
  end process;
end myarch;




